Index: crt/locale/locale.c
===================================================================
--- crt/locale/locale.c	(revision 47065)
+++ crt/locale/locale.c	(working copy)
@@ -645,7 +1311,6 @@
   int ret;
   int i;
 
-  TRACE("_setmbcp %d\n",cp);
   switch (cp)
   {
     case _MB_CP_ANSI:
@@ -655,7 +1320,7 @@
       newcp = GetOEMCP();
       break;
     case _MB_CP_LOCALE:
-      newcp = MSVCRT___lc_codepage;
+      newcp = locale->locinfo->lc_codepage;
       break;
     case _MB_CP_SBCS:
       newcp = 20127;   /* ASCII */
@@ -667,8 +1332,8 @@
 
   if (!GetCPInfo(newcp, &cpi))
   {
-    ERR("Codepage %d not found\n", newcp);
-    __set_errno(EINVAL);
+    WARN("Codepage %d not found\n", newcp);
+    *_errno() = EINVAL;
     return -1;
   }
 
@@ -694,7 +1359,7 @@
       if (cpextra->cp == 0 || cpextra->cp == newcp)
       {
         if (cpextra->cp == 0)
-          ERR("trail bytes data not available for DBCS codepage %d - assuming all bytes\n", newcp);
+          FIXME("trail bytes data not available for DBCS codepage %d - assuming all bytes\n", newcp);
 
         bytes = cpextra->TrailBytes;
         while (bytes[0] || bytes[1])
@@ -748,156 +1413,8 @@
       _mbctype[i + 1] |= _MS;
   }
 
-  MSVCRT___lc_collate_cp = MSVCRT___lc_codepage = newcp;
-  TRACE("(%d) -> %d\n", cp, MSVCRT___lc_codepage);
+  locale->locinfo->lc_collate_cp = newcp;
+  locale->locinfo->lc_codepage = newcp;
+  TRACE("(%d) -> %d\n", cp, locale->locinfo->lc_codepage);
   return 0;
 }
-
-
-/*********************************************************************
- *		__lc_collate_cp (MSVCRT.@)
- *
- * @unimplemented
- */
-void __lc_collate_cp(int cp)
-{
-FIXME("__lc_collate_cp - stub\n");
-return;
-}
-
-
-/*********************************************************************
- *		__lc_handle (MSVCRT.@)
- *
- * @unimplemented
- */
-void __lc_handle(void)
-{
-FIXME("__lc_handle - stub\n");
-return;
-}
-
-
-/*********************************************************************
- *		__lc_codepage (MSVCRT.@)
- *
- * @unimplemented
- */
-void __lc_codepage(void)
-{
-FIXME("__lc_codepage - stub\n");
-return;
-}
-
-
-/*********************************************************************
- *    _Gettnames (MSVCRT.@)
- */
-void *_Gettnames(void)
-{
-  FIXME("(void), stub!\n");
-  return NULL;
-}
-
-/*********************************************************************
- *    __lconv_init (MSVCRT.@)
- */
-void __lconv_init(void)
-{
-  char Char = (char) UCHAR_MAX;
-
-  TRACE("__lconv_init()\n");
-
-  _lconv.int_frac_digits = Char;
-  _lconv.frac_digits = Char;
-  _lconv.p_sep_by_space = _lconv.n_sep_by_space = Char;
-  _lconv.p_cs_precedes = _lconv.n_cs_precedes = Char;
-  _lconv.p_sign_posn = _lconv.n_sign_posn = Char;
-}
-
-
-/*********************************************************************
- *    _Strftime (MSVCRT.@)
- */
-const char* _Strftime(char *out, unsigned int len, const char *fmt,
-                                     const void *tm, void *foo)
-{
-  /* FIXME: */
-  FIXME("(%p %d %s %p %p) stub\n", out, len, fmt, tm, foo);
-  return "";
-}
-
-
-/*********************************************************************
- *    _Getdays (MSVCRT.@)
- */
-const char* _Getdays(void)
-{
-  static const char *MSVCRT_days = ":Sun:Sunday:Mon:Monday:Tue:Tuesday:Wed:"
-                            "Wednesday:Thu:Thursday:Fri:Friday:Sat:Saturday";
-  /* FIXME: Use locale */
-  FIXME("(void) semi-stub\n");
-  return MSVCRT_days;
-}
-
-/*********************************************************************
- *    _Getmonths (MSVCRT.@)
- */
-const char* _Getmonths(void)
-{
-  static const char *MSVCRT_months = ":Jan:January:Feb:February:Mar:March:Apr:"
-                "April:May:May:Jun:June:Jul:July:Aug:August:Sep:September:Oct:"
-                "October:Nov:November:Dec:December";
-  /* FIXME: Use locale */
-  FIXME("(void) semi-stub\n");
-  return MSVCRT_months;
-}
-
-/*********************************************************************
- *    __crtLCMapStringA (MSVCRT.@)
- */
-int __crtLCMapStringA(
-  LCID lcid, DWORD mapflags, const char* src, int srclen, char* dst,
-  int dstlen, unsigned int codepage, int xflag
-) {
-  TRACE("(lcid %lx, flags %lx, %s(%d), %p(%d), %x, %d), partial stub!\n",
-        lcid,mapflags,src,srclen,dst,dstlen,codepage,xflag);
-  /* FIXME: A bit incorrect. But msvcrt itself just converts its
-   * arguments to wide strings and then calls LCMapStringW
-   */
-  return LCMapStringA(lcid,mapflags,src,srclen,dst,dstlen);
-}
-
-/*********************************************************************
- *    __crtLCMapStringW (MSVCRT.@)
- */
-int __crtLCMapStringW(
-  LCID lcid, DWORD mapflags, LPCWSTR src, int srclen, LPWSTR dst,
-  int dstlen, unsigned int codepage, int xflag
-) {
-  TRACE("(lcid %lx, flags %lx, %s(%d), %p(%d), %x, %d), partial stub!\n",
-        lcid,mapflags,src,srclen,dst,dstlen,codepage,xflag);
-
-  return LCMapStringW(lcid,mapflags,src,srclen,dst,dstlen);
-}
-
-int CDECL _getmbcp(void)
-{
-    return MSVCRT___lc_codepage;
-}
-
-/*********************************************************************
- *		___unguarded_readlc_active_add_func (MSVCRT.@)
- */
-unsigned int * CDECL ___unguarded_readlc_active_add_func(void)
-{
-  return &__unguarded_readlc_active;
-}
-
-/*********************************************************************
- *		___setlc_active_func (MSVCRT.@)
- */
-unsigned int CDECL ___setlc_active_func(void)
-{
-  return __setlc_active;
-}
Index: crt/math/rand.c
===================================================================
--- crt/math/rand.c	(revision 47065)
+++ crt/math/rand.c	(working copy)
@@ -1,6 +1,6 @@
 /* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
 #include <precomp.h>
-
+#include <Ntsecapi.h>
 #include <internal/tls.h>
 
 /*
@@ -25,3 +25,18 @@
 
   ThreadData->tnext = (ULONGLONG)seed;
 }
+
+ /*********************************************************************
+  *              rand_s (MSVCRT.@)
+  */
+int CDECL rand_s(unsigned int *pval)
+{
+#if 0
+    if (!pval || !RtlGenRandom(pval, sizeof(*pval)))
+    {
+        *_errno() = EINVAL;
+        return EINVAL;
+    }
+#endif
+    return 0;
+}
Index: crt/mbstring/jistojms.c
===================================================================
--- crt/mbstring/jistojms.c	(revision 47065)
+++ crt/mbstring/jistojms.c	(working copy)
@@ -25,6 +25,7 @@
 #include <precomp.h>
 #include <mbstring.h>
 #include <locale.h>
+#include <internal/wine/msvcrt.h>
 
 /*
  * @implemented
@@ -33,7 +34,7 @@
 {
  /* Conversion takes place only when codepage is 932.
      In all other cases, c is returned unchanged */
-  if(MSVCRT___lc_codepage == 932)
+  if(get_locale()->locinfo->lc_codepage == 932)
   {
     if(HIBYTE(c) >= 0x21 && HIBYTE(c) <= 0x7e &&
        LOBYTE(c) >= 0x21 && LOBYTE(c) <= 0x7e)
Index: crt/misc/stubs.c
===================================================================
--- crt/misc/stubs.c	(revision 47065)
+++ crt/misc/stubs.c	(working copy)
@@ -2,7 +2,8 @@
 
 int __STRINGTOLD( long double *value, char **endptr, const char *str, int flags )
 {
-   FIXME("%p %p %s %x stub\n", value, endptr, str, flags );
+   FIXME("%p %p %s %x partial stub\n", value, endptr, str, flags );
+   *value = strtold(str,endptr);
    return 0;
 }
 
@@ -15,11 +16,6 @@
   /* FIXME: This is probably data, not a function */
 }
 
-void __p__amblksiz(void)
-{
-   FIXME("__p__amblksiz stub\n");
-}
-
 void __fileinfo(void)
 {
    FIXME("__fileinfo stub\n");
@@ -30,3 +26,15 @@
    FIXME("stub\n");
 }
 
+/*********************************************************************
+ *              _daylight (MSVCRT.@)
+ */
+int MSVCRT___daylight = 0;
+
+/*********************************************************************
+ *              __p_daylight (MSVCRT.@)
+ */
+int * CDECL MSVCRT___p__daylight(void)
+{
+    return &MSVCRT___daylight;
+}
Index: crt/precomp.h
===================================================================
--- crt/precomp.h	(revision 47065)
+++ crt/precomp.h	(working copy)
@@ -34,6 +34,7 @@
 #endif
 
 #include "wine/unicode.h"
+#include "wine/config.h"
 
 /* kernelmode libcnt should not include Wine-debugging crap */
 #ifndef _LIBCNT_
Index: crt/stdio/file.c
===================================================================
--- crt/stdio/file.c	(revision 47065)
+++ crt/stdio/file.c	(working copy)
@@ -37,7 +37,7 @@
 
 #include <precomp.h>
 #include "wine/unicode.h"
-
+#include <internal/wine/msvcrt.h>
 #include <sys/utime.h>
 #include <direct.h>
 
@@ -123,6 +123,17 @@
   return fd >= 0 && fd < fdend && (fdesc[fd].wxflag & WX_OPEN);
 }
 
+/* INTERNAL: Create a wide string from an ascii string */
+wchar_t *msvcrt_wstrdupa(const char *str)
+{
+  const unsigned int len = strlen(str) + 1 ;
+  wchar_t *wstr = malloc(len* sizeof (wchar_t));
+  if (!wstr)
+    return NULL;
+   MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,str,len,wstr,len);
+  return wstr;
+}
+
 /* INTERNAL: Get the HANDLE for a fd
  * This doesn't lock the table, because a failure will result in
  * INVALID_HANDLE_VALUE being returned, which should be handled correctly.  If
@@ -175,6 +186,7 @@
   if (fd >= MAX_FILES)
   {
     WARN(":files exhausted!\n");
+    *_errno() = ENFILE;
     return -1;
   }
   fdesc[fd].handle = hand;
@@ -341,9 +353,10 @@
   if (!(fdesc[0].wxflag & WX_OPEN) || fdesc[0].handle == INVALID_HANDLE_VALUE)
   {
 #ifndef __REACTOS__
-    DuplicateHandle(GetCurrentProcess(), GetStdHandle(STD_INPUT_HANDLE),
-                    GetCurrentProcess(), &fdesc[0].handle, 0, TRUE, 
-                    DUPLICATE_SAME_ACCESS);
+      HANDLE std = GetStdHandle(STD_INPUT_HANDLE);
+      if (std != INVALID_HANDLE_VALUE && DuplicateHandle(GetCurrentProcess(), std,
+                                                         GetCurrentProcess(), &MSVCRT_fdesc[0].handle,
+                                                         0, TRUE, DUPLICATE_SAME_ACCESS))
 #else
       fdesc[0].handle = GetStdHandle(STD_INPUT_HANDLE);
       if (fdesc[0].handle == NULL)
@@ -354,9 +367,10 @@
   if (!(fdesc[1].wxflag & WX_OPEN) || fdesc[1].handle == INVALID_HANDLE_VALUE)
   {
 #ifndef __REACTOS__
-      DuplicateHandle(GetCurrentProcess(), GetStdHandle(STD_OUTPUT_HANDLE),
-                    GetCurrentProcess(), &fdesc[1].handle, 0, TRUE, 
-                    DUPLICATE_SAME_ACCESS);
+      HANDLE std = GetStdHandle(STD_OUTPUT_HANDLE);
+      if (std != INVALID_HANDLE_VALUE && DuplicateHandle(GetCurrentProcess(), std,
+                                                         GetCurrentProcess(), &MSVCRT_fdesc[1].handle,
+                                                         0, TRUE, DUPLICATE_SAME_ACCESS))
 #else
       fdesc[1].handle = GetStdHandle(STD_OUTPUT_HANDLE);
       if (fdesc[1].handle == NULL)
@@ -367,9 +381,10 @@
   if (!(fdesc[2].wxflag & WX_OPEN) || fdesc[2].handle == INVALID_HANDLE_VALUE)
   {
 #ifndef __REACTOS__
-      DuplicateHandle(GetCurrentProcess(), GetStdHandle(STD_ERROR_HANDLE),
-                    GetCurrentProcess(), &fdesc[2].handle, 0, TRUE, 
-                    DUPLICATE_SAME_ACCESS);
+      HANDLE std = GetStdHandle(STD_ERROR_HANDLE);
+      if (std != INVALID_HANDLE_VALUE && DuplicateHandle(GetCurrentProcess(), std,
+                                                         GetCurrentProcess(), &MSVCRT_fdesc[2].handle,
+                                                         0, TRUE, DUPLICATE_SAME_ACCESS))
 #else
       fdesc[2].handle = GetStdHandle(STD_ERROR_HANDLE);
       if (fdesc[2].handle == NULL)
@@ -448,11 +463,11 @@
 }
 
 /*********************************************************************
- *		__p__iob(MSVCRT.@)
+ *		__iob_func(MSVCRT.@)
  */
-FILE * CDECL __p__iob(void)
+FILE * CDECL __iob_func(void)
 {
- return _iob;
+ return &_iob[0];
 }
 
 /*********************************************************************
@@ -986,9 +1001,9 @@
   clearerr(file);
 }
 
-static int get_flags(const char* mode, int *open_flags, int* stream_flags)
+static int get_flags(const wchar_t* mode, int *open_flags, int* stream_flags)
 {
-  int plus = strchr(mode, '+') != NULL;
+  int plus = strchrW(mode, '+') != NULL;
 
   switch(*mode++)
   {
@@ -1005,6 +1020,8 @@
     *stream_flags = plus ? _IORW : _IOWRT;
     break;
   default:
+    _invalid_parameter(NULL, NULL, NULL, 0, 0);
+    *_errno() = EINVAL;
     return -1;
   }
 
@@ -1020,6 +1037,7 @@
       *open_flags &= ~_O_BINARY;
       break;
     case '+':
+    case ' ':
       break;
     default:
       FIXME(":unknown flag %c not supported\n",mode[-1]);
@@ -1032,6 +1050,22 @@
  */
 FILE* CDECL _fdopen(int fd, const char *mode)
 {
+    FILE *ret;
+    wchar_t *modeW = NULL;
+
+    if (mode && !(modeW = msvcrt_wstrdupa(mode))) return NULL;
+
+    ret = _wfdopen(fd, modeW);
+
+    free(modeW);
+    return ret;
+}
+
+/*********************************************************************
+ *		_wfdopen (MSVCRT.@)
+ */
+FILE* CDECL _wfdopen(int fd, const wchar_t *mode)
+{
   int open_flags, stream_flags;
   FILE* file;
 
@@ -1045,51 +1079,13 @@
     file->_flag = 0;
     file = NULL;
   }
-  else TRACE(":fd (%d) mode (%s) FILE* (%p)\n",fd,mode,file);
+  else TRACE(":fd (%d) mode (%s) FILE* (%p)\n", fd, debugstr_w(mode), file);
   UNLOCK_FILES();
 
   return file;
 }
 
 /*********************************************************************
- *		_wfdopen (MSVCRT.@)
- */
-FILE* CDECL _wfdopen(int fd, const wchar_t *mode)
-{
-  unsigned mlen = strlenW(mode);
-  char *modea = calloc(mlen + 1, 1);
-  FILE* file = NULL;
-  int open_flags, stream_flags;
-
-  if (modea &&
-      WideCharToMultiByte(CP_ACP,0,mode,mlen,modea,mlen,NULL,NULL))
-  {
-      if (get_flags(modea, &open_flags, &stream_flags) == -1)
-      {
-        free(modea);
-        return NULL;
-      }
-      LOCK_FILES();
-      if (!(file = alloc_fp()))
-        file = NULL;
-      else if (init_fp(file, fd, stream_flags) == -1)
-      {
-        file->_flag = 0;
-        file = NULL;
-      }
-      else
-      {
-        if (file)
-          rewind(file); /* FIXME: is this needed ??? */
-        TRACE(":fd (%d) mode (%s) FILE* (%p)\n",fd,debugstr_w(mode),file);
-      }
-      UNLOCK_FILES();
-  }
-  free(modea);
-  return file;
-}
-
-/*********************************************************************
  *		_filelength (MSVCRT.@)
  */
 LONG CDECL _filelength(int fd)
@@ -1137,41 +1133,6 @@
 }
 
 /*********************************************************************
- *		_futime (MSVCRT.@)
- */
-int CDECL _futime(int fd, struct _utimbuf *t)
-{
-  HANDLE hand = fdtoh(fd);
-  FILETIME at, wt;
-
-  if (hand == INVALID_HANDLE_VALUE)
-    return -1;
-
-  if (!t)
-  {
-    time_t currTime;
-    time(&currTime);
-    RtlSecondsSince1970ToTime(currTime, (LARGE_INTEGER *)&at);
-    wt = at;
-  }
-  else
-  {
-    RtlSecondsSince1970ToTime(t->actime, (LARGE_INTEGER *)&at);
-    if (t->actime == t->modtime)
-      wt = at;
-    else
-      RtlSecondsSince1970ToTime(t->modtime, (LARGE_INTEGER *)&wt);
-  }
-
-  if (!SetFileTime(hand, NULL, &at, &wt))
-  {
-    _dosmaperr(GetLastError());
-    return -1 ;
-  }
-  return 0;
-}
-
-/*********************************************************************
  *		_get_osfhandle (MSVCRT.@)
  */
 intptr_t CDECL _get_osfhandle(int fd)
@@ -1179,7 +1140,7 @@
   HANDLE hand = fdtoh(fd);
   TRACE(":fd (%d) handle (%p)\n",fd,hand);
 
-  return (long)(LONG_PTR)hand;
+  return (intptr_t)hand;
 }
 
 /*********************************************************************
@@ -1444,24 +1405,95 @@
  */
 int CDECL _wsopen( const wchar_t* path, int oflags, int shflags, ... )
 {
-  const unsigned int len = strlenW(path);
-  char *patha = calloc(len + 1,1);
   va_list ap;
   int pmode;
+  DWORD access = 0, creation = 0, attrib;
+  DWORD sharing;
+  int wxflag = 0, fd;
+  HANDLE hand;
+  SECURITY_ATTRIBUTES sa;
 
-  va_start(ap, shflags);
-  pmode = va_arg(ap, int);
-  va_end(ap);
 
-  if (patha && WideCharToMultiByte(CP_ACP,0,path,len,patha,len,NULL,NULL))
+  TRACE(":file (%s) oflags: 0x%04x shflags: 0x%04x\n",
+        debugstr_w(path), oflags, shflags);
+
+  wxflag = split_oflags(oflags);
+  switch (oflags & (_O_RDONLY | _O_WRONLY | _O_RDWR))
   {
-    int retval = _sopen(patha,oflags,shflags,pmode);
-    free(patha);
-    return retval;
+  case _O_RDONLY: access |= GENERIC_READ; break;
+  case _O_WRONLY: access |= GENERIC_WRITE; break;
+  case _O_RDWR:   access |= GENERIC_WRITE | GENERIC_READ; break;
   }
-  _dosmaperr(GetLastError());
-  free(patha);
-  return -1;
+
+  if (oflags & _O_CREAT)
+  {
+    va_start(ap, shflags);
+    pmode = va_arg(ap, int);
+    va_end(ap);
+
+    if(pmode & ~(_S_IREAD | _S_IWRITE))
+      FIXME(": pmode 0x%04x ignored\n", pmode);
+    else
+      WARN(": pmode 0x%04x ignored\n", pmode);
+
+    if (oflags & _O_EXCL)
+      creation = CREATE_NEW;
+    else if (oflags & _O_TRUNC)
+      creation = CREATE_ALWAYS;
+    else
+      creation = OPEN_ALWAYS;
+  }
+  else  /* no MSVCRT__O_CREAT */
+  {
+    if (oflags & _O_TRUNC)
+      creation = TRUNCATE_EXISTING;
+    else
+      creation = OPEN_EXISTING;
+  }
+
+  switch( shflags )
+  {
+    case _SH_DENYRW:
+      sharing = 0L;
+      break;
+    case _SH_DENYWR:
+      sharing = FILE_SHARE_READ;
+      break;
+    case _SH_DENYRD:
+      sharing = FILE_SHARE_WRITE;
+      break;
+    case _SH_DENYNO:
+      sharing = FILE_SHARE_READ | FILE_SHARE_WRITE;
+      break;
+    default:
+      ERR( "Unhandled shflags 0x%x\n", shflags );
+      return -1;
+  }
+  attrib = FILE_ATTRIBUTE_NORMAL;
+
+  if (oflags & _O_TEMPORARY)
+  {
+      attrib |= FILE_FLAG_DELETE_ON_CLOSE;
+      access |= DELETE;
+      sharing |= FILE_SHARE_DELETE;
+  }
+
+  sa.nLength              = sizeof( SECURITY_ATTRIBUTES );
+  sa.lpSecurityDescriptor = NULL;
+  sa.bInheritHandle       = (oflags & _O_NOINHERIT) ? FALSE : TRUE;
+
+  hand = CreateFileW(path, access, sharing, &sa, creation, attrib, 0);
+
+  if (hand == INVALID_HANDLE_VALUE)  {
+    WARN(":failed-last error (%d)\n",GetLastError());
+    _dosmaperr(GetLastError());
+    return -1;
+  }
+
+  fd = alloc_fd(hand, wxflag);
+
+  TRACE(":fd (%d) handle (%p)\n",fd, hand);
+  return fd;
 }
 
 /*********************************************************************
@@ -1488,24 +1520,18 @@
  */
 int CDECL _wopen(const wchar_t *path,int flags,...)
 {
-  const unsigned int len = strlenW(path);
-  char *patha = calloc(len + 1,1);
   va_list ap;
-  int pmode;
 
-  va_start(ap, flags);
-  pmode = va_arg(ap, int);
-  va_end(ap);
-
-  if (patha && WideCharToMultiByte(CP_ACP,0,path,len,patha,len,NULL,NULL))
+  if (flags & _O_CREAT)
   {
-    int retval = _open(patha,flags,pmode);
-    free(patha);
-    return retval;
+    int pmode;
+    va_start(ap, flags);
+    pmode = va_arg(ap, int);
+    va_end(ap);
+    return _wsopen( path, flags, _SH_DENYNO, pmode );
   }
-  free(patha);
-  _dosmaperr(GetLastError());
-  return -1;
+  else
+    return _wsopen( path, flags, _SH_DENYNO);
 }
 
 /*********************************************************************
@@ -1570,6 +1596,10 @@
 
 /*********************************************************************
  * (internal) read_i
+ *
+ * When reading \r as last character in text mode, read() positions
+ * the file pointer on the \r character while getc() goes on to
+ * the following \n
  */
 static int read_i(int fd, void *buf, unsigned int count)
 {
@@ -1603,7 +1633,7 @@
         }
         else if (fdesc[fd].wxflag & WX_TEXT)
         {
-              DWORD i, j;
+            DWORD i, j;
             if (bufstart[num_read-1] == '\r')
             {
                 if(count == 1)
@@ -1751,38 +1781,6 @@
 }
 
 /*********************************************************************
- *		_utime (MSVCRT.@)
- */
-int CDECL _utime(const char* path, struct _utimbuf *t)
-{
-  int fd = _open(path, _O_WRONLY | _O_BINARY);
-
-  if (fd > 0)
-  {
-    int retVal = _futime(fd, t);
-    _close(fd);
-    return retVal;
-  }
-  return -1;
-}
-
-/*********************************************************************
- *		_wutime (MSVCRT.@)
- */
-int CDECL _wutime(const wchar_t* path, struct _utimbuf *t)
-{
-  int fd = _wopen(path, _O_WRONLY | _O_BINARY);
-
-  if (fd > 0)
-  {
-    int retVal = _futime(fd, t);
-    _close(fd);
-    return retVal;
-  }
-  return -1;
-}
-
-/*********************************************************************
  *		_write (MSVCRT.@)
  */
 int CDECL _write(int fd, const void* buf, unsigned int count)
@@ -2025,7 +2023,8 @@
   if (!(fdesc[file->_file].wxflag & WX_TEXT))
     {
       wchar_t wc;
-      int i,j;
+      unsigned int i;
+      int j;
       char *chp, *wcp;
       wcp = (char *)&wc;
       for(i=0; i<sizeof(wc); i++)
@@ -2052,7 +2051,7 @@
     }
     
   c = fgetc(file);
-  if ((*__p___mb_cur_max() > 1) && isleadbyte(c))
+  if ((get_locale()->locinfo->mb_cur_max > 1) && isleadbyte(c))
     {
       FIXME("Treat Multibyte characters\n");
     }
@@ -2068,7 +2067,8 @@
 int CDECL _getw(FILE* file)
 {
   char *ch;
-  int i, j, k;
+  int i, k;
+  unsigned int j;
   ch = (char *)&i;
   for (j=0; j<sizeof(int); j++) {
     k = fgetc(file);
@@ -2192,26 +2192,26 @@
 }
 
 /*********************************************************************
- *		_fsopen (MSVCRT.@)
+ *		_wfsopen (MSVCRT.@)
  */
-FILE * CDECL _fsopen(const char *path, const char *mode, int share)
+FILE * CDECL _wfsopen(const wchar_t *path, const wchar_t *mode, int share)
 {
   FILE* file;
   int open_flags, stream_flags, fd;
 
-  TRACE("(%s,%s)\n",path,mode);
+  TRACE("(%s,%s)\n", debugstr_w(path), debugstr_w(mode));
 
   /* map mode string to open() flags. "man fopen" for possibilities. */
   if (get_flags(mode, &open_flags, &stream_flags) == -1)
       return NULL;
 
   LOCK_FILES();
-  fd = _sopen(path, open_flags, share, _S_IREAD | _S_IWRITE);
+  fd = _wsopen(path, open_flags, share, _S_IREAD | _S_IWRITE);
   if (fd < 0)
     file = NULL;
   else if ((file = alloc_fp()) && init_fp(file, fd, stream_flags)
    != -1)
-    TRACE(":fd (%d) mode (%s) FILE* (%p)\n",fd,mode,file);
+    TRACE(":fd (%d) mode (%s) FILE* (%p)\n", fd, debugstr_w(mode), file);
   else if (file)
   {
     file->_flag = 0;
@@ -2226,29 +2226,31 @@
 }
 
 /*********************************************************************
- *		_wfsopen (MSVCRT.@)
+ *		_fsopen (MSVCRT.@)
  */
-FILE * CDECL _wfsopen(const wchar_t *path, const wchar_t *mode, int share)
+FILE * CDECL _fsopen(const char *path, const char *mode, int share)
 {
-  const unsigned int plen = strlenW(path), mlen = strlenW(mode);
-  char *patha = calloc(plen + 1, 1);
-  char *modea = calloc(mlen + 1, 1);
+    FILE *ret;
+    wchar_t *pathW = NULL, *modeW = NULL;
 
-  TRACE("(%s,%s)\n",debugstr_w(path),debugstr_w(mode));
+    if (path && !(pathW = msvcrt_wstrdupa(path))) {
+        _invalid_parameter(NULL, NULL, NULL, 0, 0);
+        *_errno() = EINVAL;
+        return NULL;
+    }
+    if (mode && !(modeW = msvcrt_wstrdupa(mode)))
+    {
+        free(pathW);
+        _invalid_parameter(NULL, NULL, NULL, 0, 0);
+        *_errno() = EINVAL;
+        return NULL;
+    }
 
-  if (patha && modea &&
-      WideCharToMultiByte(CP_ACP,0,path,plen,patha,plen,NULL,NULL) &&
-      WideCharToMultiByte(CP_ACP,0,mode,mlen,modea,mlen,NULL,NULL))
-  {
-    FILE *retval = _fsopen(patha,modea,share);
-    free(patha);
-    free(modea);
-    return retval;
-  }
-  free(patha);
-  free(modea);
-  _dosmaperr(GetLastError());
-  return NULL;
+    ret = _wfsopen(pathW, modeW, share);
+
+    free(pathW);
+    free(modeW);
+    return ret;
 }
 
 /*********************************************************************
@@ -2260,6 +2262,25 @@
 }
 
 /*********************************************************************
+ *              fopen_s (MSVCRT.@)
+ */
+int CDECL fopen_s(FILE** pFile,
+        const char *filename, const char *mode)
+{
+    if(!pFile) {
+        _invalid_parameter(NULL, NULL, NULL, 0, 0);
+        *_errno() = EINVAL;
+        return EINVAL;
+    }
+
+    *pFile = fopen(filename, mode);
+
+    if(!*pFile)
+        return *_errno();
+    return 0;
+}
+
+/*********************************************************************
  *		_wfopen (MSVCRT.@)
  */
 FILE * CDECL _wfopen(const wchar_t *path, const wchar_t *mode)
@@ -2267,6 +2288,25 @@
     return _wfsopen( path, mode, _SH_DENYNO );
 }
 
+/*********************************************************************
+ *		_wfopen_s (MSVCRT.@)
+ */
+int CDECL _wfopen_s(FILE** pFile, const wchar_t *filename,
+        const wchar_t *mode)
+{
+    if(!pFile) {
+        _invalid_parameter(NULL, NULL, NULL, 0, 0);
+        *_errno() = EINVAL;
+        return EINVAL;
+    }
+
+    *pFile = _wfopen(filename, mode);
+
+    if(!*pFile)
+        return *_errno();
+    return 0;
+}
+
 /* fputc calls _flsbuf which calls fputc */
 int CDECL _flsbuf(int c, FILE* file);
 
@@ -2310,7 +2350,7 @@
         int res=flush_buffer(file);
     return res?res : fputc(c, file);
   } else {
-    unsigned char cc=c;
+	unsigned char cc=c;
         int len;
         /* set _cnt to 0 for unbuffered FILEs */
         file->_cnt = 0;
@@ -2402,14 +2442,14 @@
 }
 
 /*********************************************************************
- *		freopen (MSVCRT.@)
+ *		_wfreopen (MSVCRT.@)
  *
  */
-FILE* CDECL freopen(const char *path, const char *mode,FILE* file)
+FILE* CDECL _wfreopen(const wchar_t *path, const wchar_t *mode, FILE* file)
 {
   int open_flags, stream_flags, fd;
 
-  TRACE(":path (%p) mode (%s) file (%p) fd (%d)\n",path,mode,file,file->_file);
+  TRACE(":path (%p) mode (%s) file (%p) fd (%d)\n", debugstr_w(path), debugstr_w(mode), file, file->_file);
 
   LOCK_FILES();
   if (!file || ((fd = file->_file) < 0) || fd > fdend)
@@ -2422,7 +2462,7 @@
       file = NULL;
     else
     {
-      fd = _open(path, open_flags, _S_IREAD | _S_IWRITE);
+      fd = _wopen(path, open_flags, _S_IREAD | _S_IWRITE);
       if (fd < 0)
         file = NULL;
       else if (init_fp(file, fd, stream_flags) == -1)
@@ -2439,40 +2479,26 @@
 }
 
 /*********************************************************************
- *		wfreopen (MSVCRT.@)
+ *      freopen (MSVCRT.@)
  *
  */
-FILE* CDECL _wfreopen(const wchar_t *path, const wchar_t *mode,FILE* file)
+FILE* CDECL freopen(const char *path, const char *mode, FILE* file)
 {
-  int open_flags, stream_flags, fd;
+    FILE *ret;
+    wchar_t *pathW = NULL, *modeW = NULL;
 
-  TRACE(":path (%p) mode (%s) file (%p) fd (%d)\n", debugstr_w(path), debugstr_w(mode), file, file->_file);
-
-  LOCK_FILES();
-  if (!file || ((fd = file->_file) < 0) || fd > fdend)
-    file = NULL;
-  else
-  {
-    fclose(file);
-    /* map mode string to open() flags. "man fopen" for possibilities. */
-    if (get_flags((char*)mode, &open_flags, &stream_flags) == -1)
-      file = NULL;
-    else
+    if (path && !(pathW = msvcrt_wstrdupa(path))) return NULL;
+    if (mode && !(modeW = msvcrt_wstrdupa(mode)))
     {
-      fd = _wopen(path, open_flags, _S_IREAD | _S_IWRITE);
-      if (fd < 0)
-        file = NULL;
-      else if (init_fp(file, fd, stream_flags) == -1)
-      {
-          file->_flag = 0;
-          WARN(":failed-last error (%d)\n",GetLastError());
-          _dosmaperr(GetLastError());
-          file = NULL;
-      }
+        free(pathW);
+        return NULL;
     }
-  }
-  UNLOCK_FILES();
-  return file;
+
+    ret = _wfreopen(pathW, modeW, file);
+
+    free(pathW);
+    free(modeW);
+    return ret;
 }
 
 /*********************************************************************
@@ -2518,8 +2544,12 @@
                 if (file->_ptr[i] == '\n')
                     off--;
             }
-        }
-    }
+		        /* Black magic when reading CR at buffer boundary*/
+			if(fdesc[file->_file].wxflag & WX_READCR)
+			  off--;
+
+		}
+	}
   }
   return off + pos;
 }
@@ -2534,18 +2564,21 @@
   if(*pos == -1) return -1;
   if(file->_bufsiz)  {
     if( file->_flag & _IOWRT ) {
-        off = file->_ptr - file->_base;
-    } else {
-        off = -file->_cnt;
+		off = file->_ptr - file->_base;
+	} else {
+		off = -file->_cnt;
         if (fdesc[file->_file].wxflag & WX_TEXT) {
-            /* Black magic correction for CR removal */
-            int i;
-            for (i=0; i<file->_cnt; i++) {
-                if (file->_ptr[i] == '\n')
-                    off--;
-            }
-        }
-    }
+			/* Black magic correction for CR removal */
+			int i;
+			for (i=0; i<file->_cnt; i++) {
+				if (file->_ptr[i] == '\n')
+					off--;
+			}
+		        /* Black magic when reading CR at buffer boundary*/
+			if(fdesc[file->_file].wxflag & WX_READCR)
+			  off--;
+		}
+	}
   }
   *pos += off;
   return 0;
@@ -2861,35 +2894,9 @@
     if (!(mem = malloc(resize*sizeof(*mem))))
       return EOF;
   }
-
-  /* Check if outputting to a text-file */
-  if (fdesc[file->_file].wxflag & WX_TEXT)
-  {
-      /* Convert each character and stop at the first invalid character. Behavior verified by tests under WinXP SP2 */
-      char chMultiByte[MB_LEN_MAX];
-      int nReturn;
-      wchar_t *p;
-
-      retval = 0;
-
-      for (p = mem; *p; p++)
-      {
-          nReturn = wctomb(chMultiByte, *p);
-
-          if(nReturn == -1)
-              break;
-
-          retval += fwrite(chMultiByte, 1, nReturn, file);
-      }
-  }
-  else
-  {
-    retval = fwrite(mem, sizeof(*mem), written, file);
-  }
-
+  retval = fwrite(mem, sizeof(*mem), written, file);
   if (mem != buf)
     free (mem);
-
   return retval;
 }
 
Index: crt/stdlib/errno.c
===================================================================
--- crt/stdlib/errno.c	(revision 47065)
+++ crt/stdlib/errno.c	(working copy)
@@ -8,8 +8,11 @@
  */
 #include <precomp.h>
 #include "doserrmap.h"
+#include <errno.h>
 #include <internal/wine/msvcrt.h>
 
+static _invalid_parameter_handler invalid_parameter_handler = NULL;
+
 /*
  * @implemented
  */
@@ -113,4 +116,36 @@
     SetErrorMode( mode );
 }
 
+/******************************************************************************
+ *		_invalid_parameter (MSVCRT.@)
+ */
+void __cdecl _invalid_parameter(const wchar_t *expr, const wchar_t *func,
+                                       const wchar_t *file, unsigned int line, uintptr_t arg)
+{
+    if (invalid_parameter_handler) invalid_parameter_handler( expr, func, file, line, arg );
+    else
+    {
+        ERR( "%s:%u %s: %s %lx\n", debugstr_w(file), line, debugstr_w(func), debugstr_w(expr), arg );
+        RaiseException( STATUS_INVALID_CRUNTIME_PARAMETER, EXCEPTION_NONCONTINUABLE, 0, NULL );
+    }
+}
+
+/* _get_invalid_parameter_handler - not exported in native msvcrt, added in msvcr80 */
+_invalid_parameter_handler CDECL _get_invalid_parameter_handler(void)
+{
+    TRACE("\n");
+    return invalid_parameter_handler;
+}
+
+/* _set_invalid_parameter_handler - not exproted in native msvcrt, added in msvcr80 */
+_invalid_parameter_handler CDECL _set_invalid_parameter_handler(
+        _invalid_parameter_handler handler)
+{
+    _invalid_parameter_handler old = invalid_parameter_handler;
+
+    TRACE("(%p)\n", handler);
+
+    invalid_parameter_handler = handler;
+    return old;
+}
 /* EOF */
Index: crt/string/atof.c
===================================================================
--- crt/string/atof.c	(revision 47065)
+++ crt/string/atof.c	(working copy)
@@ -1,11 +1,17 @@
 /* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
 #include <precomp.h>
+#include <stdlib.h>
 
 /*
  * @implemented
  */
-double
-atof(const char *ascii)
+double CDECL
+atof(const char *str)
 {
-  return strtod(ascii, 0);
+  return _strtod_l(str, NULL,NULL);
 }
+
+double CDECL _atof_l( const char *str, _locale_t locale)
+{
+    return _strtod_l(str, NULL, locale);
+}
Index: crt/string/atol.c
===================================================================
--- crt/string/atol.c	(revision 47065)
+++ crt/string/atol.c	(working copy)
@@ -15,5 +15,5 @@
 {
     /* FIXME needs error checking for huge/small values */
    //*value = strtold(str,0);
-   return -1;
+   return 0;
 }
